# Expected Usage: 
#  clearcase plugins:	ccperl plugins_xml.pl /clearcase ENABLE
#  vcm plugins:		ccperl plugins_xml.pl /vcm DISABLE
#
#     will only process plugin.xml and plugin.xml.off files 
#
# With Windows installation defaults this scrip is expected to be executed from within the clearcase plugin directory:
#    "C:\Program Files\IBM\WebSphere Studio Application Developer\plugins\com.rational.clearcase"
#

{
   if (substr($ARGV[$1],0,1) eq "/") {
      $a1 = shift(@ARGV);
      $a2 = shift(@ARGV);
      $s1 = substr($a1,1);
      &process_dir($s1,$a2);
   } else {
      print "usage: ccperl plugins_xml.pl /plugin_selector ENABLE or DISABLE \n";
   }
}

sub process_dir {
   $dirname = "..";
   $selector = ".$_[0].";
   $switcharg = "$_[1]";

   $status = opendir(DIR, $dirname)
	|| die "Can't open /plugins directory: $dirname";
   $entry = readdir(DIR);
   while (length($entry) > 0) {
      # print "$entry\n";
      if (-d $entry) {
         if ($entry eq "." || $entry eq "..") {
         }
      }  else {
         $newt = "..\\$entry.";
	 $newtdir = "..\\$entry";
	 # print "$newt\n";
	 $status = opendir(DIR1, $newt)
	     || die "Can't open plugin directory: $newt";
	 $plugin = readdir(DIR1);
	 while (length($plugin) > 0) {
      		if (-d $plugin) {
         		if ($entry eq "." || $entry eq "..") {
			}
         	} else {
		    if (rindex($newt,$selector) eq -1) {
		    } else {
      			if (rindex($plugin,"plugin.xml") eq -1) {
				# file not plugin.xml or plugin.xml.off
			} else {
			    if (length($plugin) eq length("plugin.xml")) {
				if ($switcharg eq "DISABLE") {
				    &process_file("$newtdir\\$plugin","$newtdir\\plugin.xml.off");
				    print "$entry disabled\n";
				} else {
				    print "STATUS: $entry Enabled.\n";
				}
			    } else {
				if ($switcharg eq "ENABLE") {
				    &process_file("$newtdir\\$plugin","$newtdir\\plugin.xml");
				    print "$entry enabled\n";
				} else {
				    print "STATUS: $entry Disabled.\n";
				}
			    }
 			}
		    }
		}
	       $plugin = readdir(DIR1);
         }
      }
      $entry = readdir(DIR);
   }
}

sub process_file  { 
    # Arg1 is ENABLE or DISABLE
    $fname = $_[0];
    $oname = $_[1];

    open(INPUT, "$fname")
		|| die "Can't open file to rename: $fname ";
    open(OUTPUT, ">$oname")
		|| die "Can't open renamed file: $oname ";
    $rec_separator = $/;
    $/ = undef;
    $_ = <INPUT>;

    $/ = $rec_separator;
    print OUTPUT;
    close(INPUT);  
    close(OUTPUT);
    unlink("$fname");

}



